; Assembly Header File
; Created 7/31/2002, 10:02:35 PM

;input a0=tokenized file name pointer, d3=handle
;output d3==0 if failed and handle was released
AttachHandleToVar
 movem.l a4/a5/d0,-(sp)
 move.l $c8,a4
 move.l a0,a5
 bsr GetSymPtr
 cmp.l #0,a0
 beq \nosymfound
 btst.w #9,10(a0)
 bne \badsym

\nosymfound
 move.l a5,-(sp)
 FAST_ROM_CALL SymAdd,a4
 addq.l #4,sp
 cmp.l #0,d0
 beq \badsym

 move.l d0,-(sp)
 FAST_ROM_CALL DerefSym,a4
 addq.l #4,sp
 lea 12(a0),a0	;get the handle
 move.w d3,(a0)

\cont
 movem.l (sp)+,a4/a5/d0
 rts
 
\badsym
 move.w d3,-(sp)
 FAST_ROM_CALL HeapFree,a4
 addq.l #2,sp
 moveq.w #0,d3
 bra \cont


 
;input a0=tokenized file name pointer
;output: d0.w = handle or H_NULL
GetVarHandle
 bsr GetSymPtr
 cmp.l #0,a0
 beq \bad
 move.w 12(a0),d0
\cont
 rts
\bad
 moveq.w #0,d0
 bra \cont

;input a0=tokenized file name ptr
;output a0=SYM_ENTRY structure pointer
GetSymPtr
 movem.l a1/a4/d0-d2,-(sp)
 move.l $c8,a4
 move.l a0,-(sp)
 FAST_ROM_CALL SymFind,a4
 addq.l #4,sp
 tst.l d0
 beq \badGetSymPtr
 move.l d0,-(sp)
 FAST_ROM_CALL DerefSym,a4
 addq.l #4,sp
\finGetSymPtr
 movem.l (sp)+,a1/a4/d0-d2
 rts
\badGetSymPtr
 move.l #0,a0
 bra \finGetSymPtr

;tokenized file names used by this program
 dc.b 0,"main\tetrishs"
hsfile
 dc.b 0,0
 
 EVEN
; the @ symbol will hide this variable
 dc.b 0,"main\@tetdat"
statefile
 dc.b 0


 
